# pylint: disable=C0301
"""
Imaging IO Test
-------------------------

Context
~~~~~~~~~~~~~~~~~~~~~~~~

This is a prototype exploring the capability of hardware and software to deal with the types of I/O
loads that the SDP will have to support for full-scale operation on SKA1 (and beyond). The
benchmark is written in plain C and uses MPI for communication. The source code is hosted on SKA
`GitLab <https://gitlab.com/ska-telescope/sdp/ska-sdp-exec-iotest>`_ repository and documentation
can be found `here <https://developer.skatelescope.org/projects/ska-sdp-exec-iotest/en/latest/?badge=latest>`__.

Test parameterisation
~~~~~~~~~~~~~~~~~~~~~~~~

Currently, the benchmark supports three different parameterisations namely,
- Variant of benchmark
- Number of cores
- Size of benchmark

Within variant, three different tests are defined namely, dry, write and read tests. As name
suggests dry test runs all the computations without writing the data to the disk. This benchmark
can be used to assess the computational performance of the prototype. Write test does the
computations and writes the data to the disk and hence, benchmarks the I/O performance of the
underlying file system. And finally, read test reads the data that has been written to the disk
and gives the read performance.

Size of the benchmark defines how big of the benchmark we would want to run. The size ``low-small``
indicates small image for SKA1 LOW configuration, whereas ``low-large`` is large image (96k) for
SKA1 LOW configuration. The same holds for ``mid-small`` and ``mid-large``, albeit, for SKA1 MID,
large image size is 192k.

They are defined in the ReFrame test as follows:

.. code-block:: python

  variant = parameter(['dry-test', 'write-test', 'read-test'])
  num_cores = parameter(1 << i for i in range(min, max))
  size = parameter(['tiny', 'low-small', 'low-large', 'mid-small', 'mid-large'])
  

Environment variables
~~~~~~~~~~~~~~~~~~~~~~~~

All these parameterisations are provided as tags to the ReFrame tests and hence, we can simply
choose which benchmark we want to run by specifying appropriate tags on command line. By default,
``min`` and ``max`` used to parameterise ``num_cores`` are 9 and 14, respectively. However, these
variables can be overridden using custom environment variables ``IMAGINGIOTEST_MIN`` and
``IMAGINGIOTEST_MAX``, respectively.

By default, the test will create a ``conda`` environment and run inside it for the 
sake of isolation. This can be controlled using env variable ``CREATE_CONDA_ENV``. 
By setting it to ``NO``, the test WILL NOT create ``conda`` environment.

Similarly, the performance metrics are monitored using the `perfmon <https://gitlab.com/ska-telescope/sdp/ska-sdp-perfmon>`_ toolkit. If
the user does not want to monitor metrics, it can be achieved by setting 
``MONITOR_METRICS=NO``. 

Test filtering
~~~~~~~~~~~~~~~~~~~~~~~~

The tests can be run using the following commands:

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  reframe/bin/reframe -C reframe_config.py -c apps/level1/imaging_iotest/reframe_iotest.py --run --performance-report

But first let's see the tests generated by ReFrame using ``--list`` command as follows:

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  reframe/bin/reframe -C reframe_config.py -c apps/level1/imaging_iotest/reframe_iotest.py --list

The output is shown below:

.. code-block:: bash

   [ReFrame Setup]
   version:           3.10.0-dev.3+1407ae75
   command:           '/home/mpaipuri/benchmark-tests/main/reframe/bin/reframe -c apps/level1/imaging_iotest/reframe_iotest.py -l'
   launched by:       mpaipuri@fnancy.nancy.grid5000.fr
   working directory: '/home/mpaipuri/benchmark-tests/main'
   settings file:     '/home/mpaipuri/benchmark-tests/main/reframe_config.py'
   check search path: (R) '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py'
   stage directory:   '/home/mpaipuri/benchmark-tests/main/stage'
   output directory:  '/home/mpaipuri/benchmark-tests/main/output'

    [List of matched checks]
    - ImagingIOTest_read_test_low_small_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_mid_large_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_mid_small_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_mid_large_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_low_large_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_tiny_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_mid_small_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_low_large_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_low_large_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_mid_large_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_low_small_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_low_large_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_mid_small_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_low_small_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_low_small_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_mid_small_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_tiny_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_low_large_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_tiny_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_low_large_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_mid_small_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_tiny_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_low_small_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_mid_small_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_tiny_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_tiny_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_tiny_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_mid_large_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_mid_small_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_low_large_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_tiny_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_low_small_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_tiny_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_mid_large_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_mid_large_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_tiny_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_mid_large_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_mid_large_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_low_large_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_low_large_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_low_small_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_mid_large_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_low_small_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_low_large_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_low_large_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_low_large_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_mid_small_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_low_large_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_tiny_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_low_small_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_low_large_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_tiny_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_low_small_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_mid_small_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_mid_large_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_mid_large_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_mid_small_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_low_small_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_mid_large_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_low_small_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_mid_small_128 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_tiny_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_mid_large_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_low_large_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_low_small_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_mid_small_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_mid_small_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_mid_large_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_mid_small_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_mid_small_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_read_test_tiny_8 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_low_small_64 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_write_test_mid_large_32 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_low_small_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTest_dry_test_tiny_16 (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    - ImagingIOTestBuild (found in '/home/mpaipuri/benchmark-tests/main/apps/level1/imaging_iotest/reframe_iotest.py')
    Found 76 check(s)

    Log file(s) saved in '/home/mpaipuri/benchmark-tests/main/reframe.log', '/home/mpaipuri/benchmark-tests/main/reframe.out'

As we can see, there are a lot of 76 tests generated by ReFrame and they are for a given system
partition. If we defined multiple partitions and environments, number of tests will be multiplied
by number of partitions and environments. This is not very ideal (unless we have infinite resources
to run these tests on) and usually we use test filtering to run specific tests.

For example, if we want to run ``dry-test`` with 8 nodes and ``low-small`` test case, following
commands must be used

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  IMAGINGIOTEST_MIN=3 IMAGINGIOTEST_MAX=4 reframe/bin/reframe -C reframe_config.py -c apps/level1/imaging-iotest/reframe_iotest.py --tag dry-test$ --tag low-small$ --run --performance-report
  
The environment variables ``IMAGINGIOTEST_MIN=3`` and ``IMAGINGIOTEST_MAX=4`` will generate one 
test with 8 nodes for the reservation. Similarly, tags ``dry-test$`` and ``low-small$`` will
select only tests with those tags. We can also restrict the tests for a given partition using
``--system`` flag and programming environment with ``-p`` flag.

We can run multiple tests corresponding to different MPI configurations (default values: MPI=1,2,4)
.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  vary_MPI=1 reframe/bin/reframe -C reframe_config.py -c apps/level1/imaging-iotest/reframe_iotest.py --tag dry-test$ --tag low-small$ --run --performance-report

Test class documentation
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
"""
# pylint: enable=C0301

import os
from pathlib import Path

import reframe as rfm
import reframe.utility.sanity as sn  # pylint: disable=import-error
import reframe.utility.typecheck as typ  # pylint: disable=import-error
from modules.base_class import CompileOnlyBenchmarkBase
from reframe.core.builtins import run_after, fixture, run_before, parameter, variable, performance_function
from reframe.utility import udeps  # pylint: disable=import-error

from modules.reframe_extras import AppBase
from modules.reframe_extras import FetchSourcesBase
from modules.utils import filter_systems_by_env

# pylint: disable=C0116,E0401,E0602,E1101,W0201

# Global variables
# Define varibales that will be shared across tests here
# Each test will run in its own conda environment. We define name of that environment here
ENV_NAME = 'rfm_ImagingIOTest'


class ImagingIOTestDownload(FetchSourcesBase):
    """Fixture to fetch Imaging IO test source code"""
    descr = 'Fetch source code of Imaging IO test'
    sourcesdir = 'https://gitlab.com/ska-telescope/sdp/ska-sdp-exec-iotest.git'
    cnd_env_name = ENV_NAME
    
    def __init__(self):
        super().__init__()
        self.valid_prog_environs = [
            'imaging-iotest',
            'imaging-iotest-mkl',
        ]
        self.valid_systems = filter_systems_by_env(self.valid_prog_environs)
        self.maintainers = [
            'Matthieu Carrère (matthieu.carrere@oca.eu)'
        ]
        self.time_limit = '0d0h20m0s'
        self.num_nodes = 1
    
    @run_before('run')
    def set_postrun_cmds(self):
        """Pull LFS objects"""
        self.prerun_cmds.append('git lfs install')
        self.prerun_cmds.append('git lfs pull')

    @run_after('run')
    def editCMakeFindPackageMKL(self):
        """Modify the detection method for the MKL package (resolve an issue)."""
        fileNameModified = os.path.join(os.path.dirname(__file__),"cmake/modules/FindMKL.cmake")
        fileNameToChange = os.path.join(self.stagedir,"cmake/modules/FindMKL.cmake")
        fileModified = open(fileNameModified,'r')
        fileToChange=open(fileNameToChange,'w')
        fileToChange.write(fileModified.read())
        fileToChange.close()
        fileModified.close()
        
class ImagingIOTestBuild(CompileOnlyBenchmarkBase):
    """Imaging IO test compile test"""
    
    descr = 'Compile Imaging IO test from sources'
    
    # Share resource from fixture
    imaging_iotest_src = fixture(ImagingIOTestDownload, scope='session')

    def __init__(self):
        super().__init__()
        self.valid_prog_environs = [
            'imaging-iotest',
            'imaging-iotest-mkl',
        ]
        self.valid_systems = filter_systems_by_env(self.valid_prog_environs)
        self.maintainers = [
            'Mahendra Paipuri (mahendra.paipuri@inria.fr)'
        ]
        # Cross compilation is not possible on certain g5k clusters. We force
        # the job to be non-local so building will be on remote node
        if 'g5k' in self.current_system.name:
            self.build_locally = False

    
    @run_before('compile')
    def set_sourcedir(self):
        """Set source path based on dependencies"""
        self.sourcesdir = self.imaging_iotest_src.stagedir
        

    @run_before('compile')
    def set_build_system_attrs(self):
        """Set build directory and config options"""
        self.build_system = 'CMake'
        self.build_system.builddir = os.path.join(self.stagedir, 'build')
        self.build_system.max_concurrency = 8

    @run_before('sanity')
    def set_sanity_patterns(self):
        """Set sanity patterns"""
        self.sanity_patterns = sn.assert_not_found('error', self.stderr)


@rfm.simple_test
class ImagingIOTest(AppBase):
    """Main class of Imaging IO runtime tests"""

    descr = 'Imaging IO test benchmarks for compute, read and write performances.'

    # Parameterised tests
    variant = parameter(['dry-test', 'write-test', 'read-test'])
    size = parameter(['tiny', 'low-small', 'low-large', 'mid-small', 'mid-large'])

    vary_MPI = variable(int, value=int(os.getenv('vary_MPI', default=0)))

    # Variables to define number of nodes
    if vary_MPI == 1:
        # number of nodes is set to 1, 2 and 4, based on the range() function with values (0, 3).
        num_nodes = parameter(1 << i for i in range(0, 3))
    else:
    # Variables to define min and max exponents of 2 to define number of nodes
        min_expnt = variable(int, value=int(os.getenv('IMAGINGIOTEST_MIN', 3)))
        max_expnt = variable(int, value=int(os.getenv('IMAGINGIOTEST_MAX', 8)))

        num_nodes = parameter(1 << i for i in range(int(min_expnt), int(max_expnt)))

    # Dependency
    imaging_iotest_src = fixture(ImagingIOTestBuild)

    # Sanity check number of messages
    num_sm = variable(dict, value={
        'dry-test': 1,
        'write-test': 1,
        'read-test': 2,
    })

    # Benchmark configuration parameters
    benchmark = variable(dict, value={
        'tiny': {
            'image': 'small',
            'antenna': 'vlaa',
            'facet-workers': 2,
            'subgrid-workers': 0,  # 2 per NUMA node. Overridden in the test based on partition
            'aux_opts': '',
        },
        'low-small': {
            'image': 'small',
            'antenna': 'lowbd2',
            'facet-workers': 10,
            'subgrid-workers': 0,  # 2 per NUMA node. Overridden in the test based on partition
            'aux_opts': '--time=-460:460/1024/256 --freq=260e6:300e6/8192/256 --dec=-30 '
                        '--source-count=10 --send-queue=4 --subgrid-queue=16 --bls-per-task=8 '
                        '--task-queue=32 --wstep=64 --margin=32 --target-err=1e-5',
        },
        'low-large': {
            'image': '64k-16k-1k',  # For LOW we do not need to go more than 64k images
            'antenna': 'lowbd2',
            'facet-workers': 37,
            'subgrid-workers': 0,  # 2 per NUMA node. Overridden in the test based on partition
            'aux_opts': '--time=-460:460/1024/256 --freq=260e6:300e6/8192/256 --dec=-30 '
                        '--source-count=10 --send-queue=4 --subgrid-queue=16 --bls-per-task=8 '
                        '--task-queue=32 --wstep=64 --margin=32 --target-err=1e-5',
        },
        'mid-small': {
            'image': 'small',
            'antenna': 'midr5',
            'facet-workers': 10,
            'subgrid-workers': 0,  # 2 per NUMA node. Overridden in the test based on partition
            'aux_opts': '--time=-870:870/12288/128 --freq=0.35e9:0.4725e9/11264/128 '
                        '--fov=0.297204 --dec=0 --source-count=10 --send-queue=8 '
                        '--subgrid-queue=256 --bls-per-task=16 --task-queue=60 --margin=128 '
                        '--target-err=1e-5',
        },
        'mid-large': {
            'image': '128k-32k-1k',
            'antenna': 'midr5',
            'facet-workers': 37,
            'subgrid-workers': 0,  # 2 per NUMA node. Overridden in the test based on partition
            'aux_opts': '--time=-870:870/12288/128 --freq=0.35e9:0.4725e9/11264/128 '
                        '--fov=0.297204 --dec=0 --source-count=10 --send-queue=8 '
                        '--subgrid-queue=256 --bls-per-task=16 --task-queue=60 --margin=128 '
                        '--target-err=1e-5',
        },
    })

    def __init__(self):
        super().__init__()
        self.valid_prog_environs = [
            'imaging-iotest',
            'imaging-iotest-mkl',
        ]
        self.valid_systems = filter_systems_by_env(self.valid_prog_environs)
        self.maintainers = [
            'Mahendra Paipuri (mahendra.paipuri@inria.fr)'
        ]
        self.exclusive_access = True

    @run_after('setup')
    #@run_before('run')
    def set_executable(self):
        """Set executable path and executable"""
        self.executable_path = Path(os.path.join(self.imaging_iotest_src.stagedir,
                                                 'build', 'iotest')).parent.absolute()
        self.sourcesdir = self.imaging_iotest_src.stagedir
        self.executable = './iotest'

    @run_after('init')
    def set_tags(self):
        """Add tags to the test"""
        self.tags |= {
            f'size={self.size}',
            f'variant={self.variant}',
            self.size, self.variant, str(self.num_nodes)
        }

    @run_after('setup')
    def get_num_nodes(self):
        """Get number of nodes from total cores requested and number of cores per node"""
        self.num_cores = self.num_nodes * self.current_partition.processor.num_cpus
        self.tags |= {
            f'num_nodes={self.num_nodes}',
            f'num_cores={self.num_cores}',
        }

    @run_after('setup')
    def set_subgrid_workers(self):
        """Set number of subgrid workers based on NUMA nodes"""
        num_numa_nodes = self.current_partition.processor.num_sockets
        self.benchmark[self.size]['subgrid-workers'] = num_numa_nodes

    @run_after('setup')
    def set_num_tasks_job(self):
        """This method sets tasks for the job. We use this to override the num_tasks set for
        reservation. Using this approach we can set num_tasks to job in a more generic way"""
        self.num_tasks_job = (self.num_nodes * self.benchmark[self.size]['subgrid-workers'] 
                              + self.benchmark[self.size]['facet-workers'])
        self.tags |= {
            f'num_procs={self.num_tasks_job}'
        }

    @run_after('setup')
    def set_num_threads(self):
        """Set number of OpenMP threads and OpenMP environment variables"""
        self.num_threads = (self.current_partition.processor.num_cpus 
                            // self.current_partition.processor.num_sockets)
        self.variables = {
            'OMP_NUM_THREADS': str(self.num_threads),
            'OMP_PROC_BIND': 'true',
            'OMP_PLACES': 'sockets',
            # Without this intel MPI does not respect OMP_NUM_THREADS var
            'I_MPI_PIN_DOMAIN': 'omp',
            'KMP_AFFINITY': 'granularity=socket,compact',
        }

    @run_after('setup')
    def add_launcher_options(self):
        """Set job launcher options"""
        if self.launcher_name == 'mpirun':
            # We are patching the launcher for mpirun/mpiexec to remove -np arg
            self.job.launcher.options = [
                f'--map-by node',  
                f'-np {self.num_tasks_job}',
                # '--bind-to core:overload-allowed',  # These flags seems to be counter productive
                # '--oversubscribe',
                '--tag-output', '--timestamp-output',
            ]
        elif self.launcher_name == 'mpiexec':
            # We are patching the launcher for mpirun/mpiexec to remove -np arg
            self.job.launcher.options = [
                f'-ppn 1 -n {self.num_tasks_job}',
                '-prepend-pattern \"[%r]: \"',
            ]
        elif self.launcher_name == 'srun':
            # Same goes with --nodes=<num_tasks_job> flag
            self.job.launcher.options = [
                '--distribution=cyclic:cyclic:fcyclic',
                '--cpu-bind=verbose,sockets', '--overcommit',
                f'--ntasks={self.num_tasks_job}',
                f'--cpus-per-task={self.num_threads}',
                '--label',
        ]

    @run_after('setup')
    def set_executable_opts(self):
        """Set iotest executable options"""
        self.executable_opts = [
            f"--rec-set={self.benchmark[self.size]['image']}",
            f"--facet-workers={self.benchmark[self.size]['facet-workers']}",
            '--producer-threads=8',
            f"--vis-set={self.benchmark[self.size]['antenna']}",
            self.benchmark[self.size]['aux_opts']
        ]
        if self.variant in ['write-test', 'read-test']:
            self.executable_opts += [
                '--fork-writer',
                '--writer-count=8',
                '$SCRATCH_DIR_TEST/out%d.h5',
            ]

    @run_before('run')
    def pre_launch(self):
        """Set prerun commands. It includes setting scratch directory and pre run commands from
        base class"""
        self.prerun_cmds += [
            'export SCRATCH_DIR_TEST={}'.format(
                os.path.join('$SCRATCH_DIR', "-".join(
                    [self.current_environ.name, self.current_partition.name]
                )
                             )
            ),
            'mkdir -p -m 777 $SCRATCH_DIR_TEST',
            f'cd {self.executable_path}',
        ]

    @run_before('run')
    def post_launch(self):
        """Set post run commands. It includes removing visibility data files and running
        read-test"""
        if self.variant == 'write-test':
            self.postrun_cmds.insert(0, 'rm -rf $SCRATCH_DIR_TEST/out%d.h5')
        elif self.variant == 'read-test':
            # run_command returns with default num tasks which is 1
            cmd = self.job.launcher.run_command(self.job).replace(str(1), str(self.num_tasks_job))
            # The first job writes the visibility data and this job reads them back.
            # This gives us the read bandwidth benchmark
            exec_opts = " ".join([*self.executable_opts[:-1], '--check-existing',
                                  self.executable_opts[-1]])
            self.postrun_cmds.insert(0, f'{cmd} {self.executable} {exec_opts}')
            self.postrun_cmds.insert(1, 'rm -rf $SCRATCH_DIR_TEST/out%d.h5')
            self.postrun_cmds.insert(2, f'cd {self.executable_path}/../../ImagingIOTest_read_test_{self.size}_{self.num_nodes}')
            self.postrun_cmds.insert(3, f'sed -i "/0+0j/d" {self.stdout}')


            
    @run_before('sanity')
    def set_sanity_patterns(self):
        """Set sanity patterns. Example stdout:

        .. code-block:: text

            # Fri Jul 23 15:15:41 2021[1,0]<stdout>:Operations:

        We check number of time the above line is printed and compare it with number of
        sub grid workers
        """
        num_messages = sn.len(sn.findall(r'(.*):(\s*)Operations', self.stdout))
        self.sanity_patterns = sn.assert_eq(
            num_messages,
            self.num_nodes * self.num_sm[self.variant] *
            self.benchmark[self.size]['subgrid-workers']
        )

    @performance_function('s')
    def extract_stream_time(self):
        """Performance extraction function for stream time. Sample stdout:


        .. code-block:: text

            Fri Jul 23 15:15:41 2021[1,2]<stdout>:Streamed for 3.53s

        """
        return (sn.sum(
            sn.extractall(r'(.*):(\s*)Streamed for ([\d\.+-e]*)s', self.stdout, 3, float)) /
                sn.len(
                    sn.extractall(r'(.*):(\s*)Streamed for ([\d\.+-e]*)s', self.stdout, 3, float)))

    @performance_function('Gflop')
    def extract_degrid_flop(self):
        # pylint: disable=C0301
        """Performance extraction function for degrid flop. Sample output:

        .. code-block:: text

            # Fri Jul 23 15:15:41 2021[1,0]<stdout>: degrid 108.943 Gflops (10.9 GFlop/s, 92012544/92012544 visibilities, 1.47 GB, rate 0.15 GB/s, 25432 chunks)

        """
        # pylint: enable=C0301
        return sn.sum(sn.extractall(r'(.*):(\s+)degrid ([\d\.+-e]*)', self.stdout, 3, float))

    @performance_function('Gflop/s')
    def extract_degrid_flops(self):
        # pylint: disable=C0301
        """Performance extraction function for degrid flops. Sample output:

        .. code-block:: text

            # Fri Jul 23 15:15:41 2021[1,0]<stdout>: degrid 108.943 Gflops (10.9 GFlop/s, 92012544/92012544 visibilities, 1.47 GB, rate 0.15 GB/s, 25432 chunks)

        """
        # pylint: enable=C0301
        return sn.sum(sn.extractall(r'(.*):(\s+)degrid.*\(([\d\.+-e]*)', self.stdout, 3, float))

    @performance_function('GB/s')
    def extract_degrid_rate(self):
        # pylint: disable=C0301
        """Performance extraction function for degrid rate. Sample output:

        .. code-block:: text

            # Fri Jul 23 15:15:41 2021[1,0]<stdout>: degrid 108.943 Gflops (10.9 GFlop/s, 92012544/92012544 visibilities, 1.47 GB, rate 0.15 GB/s, 25432 chunks)
        """
        # pylint: enable=C0301
        return sn.sum(sn.extractall(r'(.*):(\s+)degrid.*\(.* ([\d\.+-e]*) GB/s', self.stdout, 3,
                                    float))

    @performance_function('Gflop')
    def extract_fft_flop(self):
        """Performance extraction function for fft flop. Sample output:

        .. code-block:: text

            # Fri Jul 23 15:15:41 2021[1,0]<stdout>: FFTs 3.296 Gflop (0.3 Gflop/s)

        """
        # pylint: enable=C0301
        return sn.sum(sn.extractall(r'(.*):(\s+)FFTs ([\d\.+-e]*) [gG]flop', self.stdout, 3, float))

    @performance_function('Gflop/s')
    def extract_fft_flops(self):
        """Performance extraction function for fft flops. Sample output:

        .. code-block:: text

            # Fri Jul 23 15:15:41 2021[1,0]<stdout>: FFTs 3.296 Gflop (0.3 Gflop/s)

        """
        # pylint: enable=C0301
        return sn.sum(sn.extractall(r'(.*):(\s+)FFTs.*\(([\d\.+-e]*)', self.stdout, 3, float))

    @performance_function('GB/s')
    def extract_write_bw(self):
        # pylint: disable=C0301
        """Performance extraction function for write bandwidth. Sample output:

        .. code-block:: text

            # Fri Jul 23 15:15:41 2021[1,2]<stdout>:Writer 2: Wait: 2.02671s, Read: 0.158911s, Write: 1.28306s, Idle: 0.0658979s

        """
        # pylint: enable=C0301
        return sn.sum(sn.extractall(r'(.*):(\s*)Writer \d*: .*rate ([\d\.+-e]*) GB/s',
                                    self.stdout, 3, float))

    @performance_function('GB/s')
    def extract_read_bw(self):
        # pylint: disable=C0301
        """Performance extraction function for read bandwidth. Sample output:

        .. code-block:: text

            # Fri Jul 23 15:15:41 2021[1,2]<stdout>:Writer 2: Wait: 2.02671s, Read: 0.158911s, Write: 1.28306s, Idle: 0.0658979s

        for dry tests, read time will be zero. To avoid ZeroDivisionError, we add a small
        threshold value
        """
        # pylint: enable=C0301
        return (sn.sum(sn.extractall(r'(.*):(\s*)Writer \d*: .*?written ([\d\.+-e]*) GB',
                                     self.stdout, 3, float)) /
                sn.max(sn.sum(sn.extractall(r'(.*):(\s*)Writer \d*: .*Read: ([\d\.+-e]*)s',
                                            self.stdout, 3, float)), 1e-3))

    @run_before('performance')
    def set_perf_patterns(self):
        """Set performance variables"""
        self.perf_variables = {
            'Stream s': self.extract_stream_time(),
            'Degrid Gflop': self.extract_degrid_flop(),
            'Degrid Gflop/s': self.extract_degrid_flops(),
            'Degrid GB/s': self.extract_degrid_rate(),
            'FFT Gflop': self.extract_fft_flop(),
            'FFT Gflop/s': self.extract_fft_flops(),
            'Write GB/s': self.extract_write_bw(),
            'Read GB/s': self.extract_read_bw(),
        }

    @run_before('performance')
    def set_reference_values(self):
        """Set reference perf values"""
        self.reference = {
            '*': {
                'Stream s': (None, None, None, 's'),
                'Degrid Gflop': (None, None, None, 'Gflop'),
                'Degrid Gflop/s': (None, None, None, 'Gflop/s'),
                'Degrid GB/s': (None, None, None, 'GB/s'),
                'FFT Gflop': (None, None, None, 'Gflop'),
                'FFT Gflop/s': (None, None, None, 'Gflop/s'),
                'Write GB/s': (None, None, None, 'GB/s'),
                'Read GB/s': (None, None, None, 'GB/s'),
            }
        }
